unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Graphics, StdCtrls, ExtCtrls, ComCtrls, Dialogs, LazUTF8,
  Classes;

type
  { TForm1 }

  TForm1 = class(TForm)
    Bevel1: TBevel;
    BtnLoadWin: TButton;
    BtnOSx: TButton;
    BtnFormIco: TButton;
    BtnSearch_Icon: TButton;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    TrackBar1: TTrackBar;
    procedure BtnLoadWinClick(Sender: TObject);
    procedure BtnOSxClick(Sender: TObject);
    procedure BtnFormIcoClick(Sender: TObject);
    procedure BtnSearch_IconClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    procedure UpdateTrackBar;

  public
  end;
  
var
  Form1: TForm1;
  s: String;

implementation

{$R *.lfm}

{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
begin
  S:= (ExtractFilePath(ParamStrUTF8(0)))  ;
end;

procedure TForm1.BtnLoadWinClick(Sender: TObject);
begin
  Image1.Picture.LoadFromFile(ExtractFilePath(ParamStrUTF8(0)) + 'icons' + PathDelim + 'lazarus.ico');
  // extracts the path from where the progarma starts +subdir +file
  Caption := 'Icon found at ' + S + 'icons' + PathDelim + 'lazarus.ico' ;

  UpdateTrackbar;
end;

procedure TForm1.BtnOSxClick(Sender: TObject);
begin
  Image1.Picture.LoadFromFile(ExtractFilePath(ParamStrUTF8(0)) + 'icons' + PathDelim + 'lazarus.icns');
  Caption := 'Icon found at ' + S + 'icons' + PathDelim + 'lazarus.icns' ;

  UpdateTrackbar;
end;

procedure TForm1.BtnFormIcoClick(Sender: TObject);
begin
  Icon.Assign(Image1.Picture.Graphic);
end;

procedure TForm1.BtnSearch_IconClick(Sender: TObject);
begin
  Try
    If OpenDialog1.Execute
    Then Image1.Picture.LoadFromFile(OpenDialog1.FileName);
    Caption := 'Icon found at ' + '  Path: ' + OpenDialog1.FileName;
  Except
      MessageDlg('Loading the icon failed', mtError, [mbOK], 0);
  End;
   UpdateTrackbar;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if TCustomIcon(Image1.Picture.Graphic).Count > TrackBar1.Position
  then TCustomIcon(Image1.Picture.Graphic).Current := TrackBar1.Position;
end;

procedure TForm1.UpdateTrackBar;
begin
  TrackBar1.Enabled := Image1.Picture.Graphic is TCustomIcon;
  if TrackBar1.Enabled then
  begin
    TrackBar1.Min := 0;
    TrackBar1.Max := TCustomIcon(Image1.Picture.Graphic).Count - 1;
    TrackBar1.Position := TCustomIcon(Image1.Picture.Graphic).Current;
    TrackBar1Change(TrackBar1);
  end;
end;


end.

